
//  Kaanna.java  Copyright (c) 2006 Kari Laitinen

//  http://www.naturalprogramming.com

//  2006-03-07  Tiedosto luotu.
//  2006-03-07  Viimeisin muutos.

//  Paras tapa tmn ohjelman suorittamiseksi on ajaa tt
//  komentorivi-ikkunassa jossa ohjelmalle voidaan sytt
//  komentoriviparametreja. Voi olla vaikeaa, ellei jopa mahdotonta,
//  antaa komentoriviparametreja silloin kun sit ajetaan
//  modernilla ohjelmakehitystykalulla kuten JCreatorilla tai
//  Eclipsell.


import java.util.ArrayList ;

class  KaksikielinenKaannos
{
   protected String ensimmainen_sana ;
   protected String toinen_sana ;

   public KaksikielinenKaannos() {}

   public KaksikielinenKaannos( String  annettu_ensimmainen_sana,
                                String  annettu_toinen_sana )
   {
      ensimmainen_sana  =  annettu_ensimmainen_sana ;
      toinen_sana       =  annettu_toinen_sana ;
   }

   public boolean kaanna( String annettu_sana )
   {
      boolean  kaantaminen_onnistui  =  false ;

      if ( annettu_sana.equals( ensimmainen_sana ) )
      {
         System.out.print( "\n \"" + annettu_sana + "\" kaantyy \""
                         + toinen_sana  + "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      if ( annettu_sana.equals( toinen_sana ) )
      {
         System.out.print( "\n \"" + annettu_sana + "\" kaantyy \""
                         + ensimmainen_sana  +  "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      return  kaantaminen_onnistui ;
   }
}


class  KolmikielinenKaannos  extends  KaksikielinenKaannos
{
   protected String kolmas_sana ;

   public KolmikielinenKaannos( String annettu_ensimmainen_sana,
                                String annettu_toinen_sana,
                                String annettu_kolmas_sana )
   {
      ensimmainen_sana  =  annettu_ensimmainen_sana ;
      toinen_sana       =  annettu_toinen_sana ;
      kolmas_sana       =  annettu_kolmas_sana ;
   }

   public boolean kaanna( String annettu_sana )
   {
      boolean  kaantaminen_onnistui  =  false ;

      if ( annettu_sana.equals( ensimmainen_sana ) )
      {
         System.out.print( "\n \"" + annettu_sana + "\" kaantyy \""
                   + toinen_sana  + "\" ja \"" + kolmas_sana + "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      if ( annettu_sana.equals( toinen_sana ) )
      {
         System.out.print( "\n \"" + annettu_sana + "\" kaantyy \""
                   + ensimmainen_sana  + "\" ja \"" + kolmas_sana  + "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      if ( annettu_sana.equals( kolmas_sana ) )
      {
         System.out.print( "\n \"" + annettu_sana + "\" kaantyy \""
                   + ensimmainen_sana  + "\" ja \"" + toinen_sana  + "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      return  kaantaminen_onnistui ;
   }
}

class Kaanna
{
   public static void main( String[] komentoriviparametrit )
   {
      ArrayList<KaksikielinenKaannos>  kaannostaulukko  =
                            new  ArrayList<KaksikielinenKaannos>() ;

      kaannostaulukko.add(
             new KaksikielinenKaannos( "week", "viikko" ) ) ;
      kaannostaulukko.add(
             new KolmikielinenKaannos( "street", "katu", "calle" ) ) ;
      kaannostaulukko.add(
             new KaksikielinenKaannos( "eat", "syoda" ) ) ;
      kaannostaulukko.add(
             new KolmikielinenKaannos( "woman", "nainen", "mujer" ) ) ;
      kaannostaulukko.add(
             new KolmikielinenKaannos( "man", "mies", "hombre" ) ) ;
      kaannostaulukko.add(
             new KaksikielinenKaannos( "sleep", "nukkua" ) ) ;

      if ( komentoriviparametrit.length  ==  1 )
      {
         int  kaannoksen_indeksi  =  0 ;

         while ( kaannoksen_indeksi  <  kaannostaulukko.size() )
         {
            kaannostaulukko.get( kaannoksen_indeksi ).
                             kaanna( komentoriviparametrit[ 0 ] ) ;

            kaannoksen_indeksi  ++  ;
         }

         System.out.print( "\n" ) ;
      }
      else
      {
         System.out.print( "\n Anna sana komentorivilla.\n\n" ) ;
      }
   }
}



